/**
 * DO NOT EDIT
 *
 * This file was automatically generated by
 *   https://github.com/Polymer/tools/tree/master/packages/gen-typescript-declarations
 *
 * To modify these typings, edit the source file(s):
 *   src/ApiOauth2SettingsDocument.js
 */


// tslint:disable:variable-name Describing an API that's defined elsewhere.
// tslint:disable:no-any describes the API as best we are able today

import {LitElement, html, css} from 'lit-element';

import {AmfHelperMixin} from '@api-components/amf-helper-mixin/amf-helper-mixin.js';

export {ApiOauth2SettingsDocument};

declare namespace ApiElements {

  /**
   * `api-oauth2-settings-document`
   *
   * Documentation view for AMF OAuth2 security settings.
   *
   * Settings can be passed by setting the `settings` property to AMF's
   * settings property of Security Scheme.
   *
   * ```html
   * <api-oauth2-settings-document
   *  amf-model="{...}"
   *  settings="{...}"></api-oauth1-settings-document>
   * ```
   *
   * It is also possible to set corresponding properties directly.
   *
   * ```html
   * <api-oauth2-settings-document
   *  amf-model="{...}"
   *  access-token-uri="https://..."
   *  authorization-uri="https://..."
   *  authorization-grants='["implicit"]'></api-oauth1-settings-document>
   * ```
   *
   * ## Styling
   *
   * `<api-oauth2-settings-document>` provides the following custom properties and mixins for styling:
   *
   * Custom property | Description | Default
   * ----------------|-------------|----------
   * `--api-oauth2-settings-document` | Mixin applied to this elment | `{}`
   */
  class ApiOauth2SettingsDocument extends
    AmfHelperMixin(
    Object) {

    /**
     * OAuth2 settings scheme of AMF.
     * When this property changes it resets other properties.
     */
    settings: object|null;

    /**
     * Access token URI value.
     * This property is updated when `settings` property chnage.
     */
    accessTokenUri: string|null|undefined;

    /**
     * Authorization URI value.
     * This property is updated when `settings` property chnage.
     */
    authorizationUri: string|null|undefined;

    /**
     * List of OAuth2 authorization grants.
     * This property is updated when `settings` property chnage.
     */
    authorizationGrants: Array<String|null>|null;

    /**
     * List of OAuth2 authorization scopes.
     * This property is updated when `settings` property chnage.
     *
     * Each array item must have `label` and optional `description`
     * properties.
     */
    scopes: Array<object|null>|null;
    render(): any;

    /**
     * Called automatically when `settings` property change (whole object,
     * not sub property).
     * Sets values of all other properties to the one found in the AMF.
     *
     * @param settings AMF settings to process.
     */
    _settingsChanged(settings: object|null): void;

    /**
     * Computes value for `accessTokenUri` property.
     *
     * @param settings OAuth2 settings from AMF model.
     */
    _computeAccessTokenUri(settings: object|null): String|null|undefined;

    /**
     * Computes value for `authorizationUri` property.
     *
     * @param settings OAuth2 settings from AMF model.
     */
    _computeAuthorizationUri(settings: object|null): String|null|undefined;

    /**
     * Computes value for `authorizationGrants` property.
     *
     * @param settings OAuth2 settings from AMF model.
     */
    _computeAuthorizationGrants(settings: object|null): Array<String|null>|null|undefined;

    /**
     * Computes value for `scopes` property.
     *
     * @param settings OAuth2 settings from AMF model.
     */
    _computeScopes(settings: object|null): Array<object|null>|null|undefined;
  }
}
